import { BaseIdToken, Rule } from './auth-type';
import { AppDomain } from '../type';
export declare type VerifyIdToken = BaseIdToken & {
    rules?: Rule[];
};
export declare const schemaVerifyIdToken: {
    rules: import("joi").ArraySchema;
    userId: import("joi").NumberSchema;
    userLogin: import("joi").StringSchema;
    localeCode: import("joi").StringSchema;
    orgId: import("joi").NumberSchema;
    appDomain: import("joi").StringSchema;
    productId: import("joi").NumberSchema;
};
export declare type BearerMetadata = {
    orgId: number;
    appDomain: AppDomain;
    productId: number;
};
export declare type AuthBearerVerify = (token: string, metadata: BearerMetadata) => Promise<VerifyIdToken>;
export declare type BasicMetadata = {
    username: string;
    password: string;
    orgId: number;
    appDomain: AppDomain;
    productId: number;
};
export declare type AuthBasicVerify = (metadata: BasicMetadata) => Promise<VerifyIdToken>;
