import { Ability } from '@casl/ability';
import { IdToken } from './auth-id-token';
import { BasicMetadata, BearerMetadata } from './auth-type-verify';
import { AppDomain } from '../type';
export declare enum AuthTokenType {
    Bearer = "Bearer",
    Basic = "Basic"
}
export declare type BaseIdToken = {
    userId: number;
    userLogin: string;
    localeCode: string;
    orgId?: number;
    appDomain?: AppDomain;
    productId?: number;
};
export declare const schemaBaseIdToken: {
    userId: import("joi").NumberSchema;
    userLogin: import("joi").StringSchema;
    localeCode: import("joi").StringSchema;
    orgId: import("joi").NumberSchema;
    appDomain: import("joi").StringSchema;
    productId: import("joi").NumberSchema;
};
export declare type AuthToken = {
    type: AuthTokenType;
    info: AccessInfo;
    grant?: boolean;
};
export declare type AccessInfo = {
    token: string;
    auth?: IdToken;
    authMetadata?: {
        bearer?: BearerMetadata;
        basic?: BasicMetadata;
        rules?: Rule[];
    };
    headers?: {
        localeCode: string;
    };
    requestedBy?: number;
    requestedByName?: string;
    ability: Ability;
};
export declare type AuthDirective = {
    type: AuthTokenType;
    hasAbility?: Rule;
    flag?: boolean;
};
export declare type Rule = {
    action: string;
    subject: string;
    fields?: string;
    inverted?: boolean;
};
export declare function generateAbility(rules?: Rule[]): Ability<import("@casl/ability").AbilityTuple<string, import("@casl/ability").Subject>, import("@casl/ability").MongoQuery<import("@casl/ability/dist/types/types").AnyObject>>;
