import { KafkaProducer } from 'cm-libs-kafka';
import { DomainEventMessage } from './domain-event';
import { DomainEventCipher } from './domain-event-cipher';
export declare function initDomainEventProducer<T, M>(schema: string | Record<string, any>, metadataSchema?: string | Record<string, any>, topics?: string[], cipher?: DomainEventCipher): DomainEventProducer<T, M>;
export declare class DomainEventProducer<T, M> {
    private readonly config;
    readonly topics: string[];
    private producer;
    private domainEvent;
    constructor(config: string, topics: string[], schema: string | Record<string, any>, metadataSchema?: string | Record<string, any>, cipher?: DomainEventCipher);
    term(): Promise<void>;
    publish(message: DomainEventMessage<T, M>, topic?: string): Promise<import("kafkajs").RecordMetadata[]>;
    getProducer(): Promise<KafkaProducer>;
    get ready(): boolean;
    get schemaRegistryId(): number;
    get metadataSchemaRegistryId(): number;
}
